// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rcss3d_agent_msgs:msg/Percept.idl
// generated code does not contain a copyright notice

#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__PERCEPT__TRAITS_HPP_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__PERCEPT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rcss3d_agent_msgs/msg/detail/percept__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'gyro_rates'
#include "rcss3d_agent_msgs/msg/detail/gyro_rate__traits.hpp"
// Member 'hinge_joints'
#include "rcss3d_agent_msgs/msg/detail/hinge_joint_pos__traits.hpp"
// Member 'universal_joints'
#include "rcss3d_agent_msgs/msg/detail/universal_joint_pos__traits.hpp"
// Member 'force_resistances'
#include "rcss3d_agent_msgs/msg/detail/force_resistance__traits.hpp"
// Member 'accelerometers'
#include "rcss3d_agent_msgs/msg/detail/accelerometer__traits.hpp"
// Member 'vision'
#include "rcss3d_agent_msgs/msg/detail/vision__traits.hpp"
// Member 'game_state'
#include "rcss3d_agent_msgs/msg/detail/game_state__traits.hpp"
// Member 'agent_state'
#include "rcss3d_agent_msgs/msg/detail/agent_state__traits.hpp"
// Member 'hears'
#include "rcss3d_agent_msgs/msg/detail/hear__traits.hpp"

namespace rcss3d_agent_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Percept & msg,
  std::ostream & out)
{
  out << "{";
  // member: gyro_rates
  {
    if (msg.gyro_rates.size() == 0) {
      out << "gyro_rates: []";
    } else {
      out << "gyro_rates: [";
      size_t pending_items = msg.gyro_rates.size();
      for (auto item : msg.gyro_rates) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: hinge_joints
  {
    if (msg.hinge_joints.size() == 0) {
      out << "hinge_joints: []";
    } else {
      out << "hinge_joints: [";
      size_t pending_items = msg.hinge_joints.size();
      for (auto item : msg.hinge_joints) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: universal_joints
  {
    if (msg.universal_joints.size() == 0) {
      out << "universal_joints: []";
    } else {
      out << "universal_joints: [";
      size_t pending_items = msg.universal_joints.size();
      for (auto item : msg.universal_joints) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: force_resistances
  {
    if (msg.force_resistances.size() == 0) {
      out << "force_resistances: []";
    } else {
      out << "force_resistances: [";
      size_t pending_items = msg.force_resistances.size();
      for (auto item : msg.force_resistances) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: accelerometers
  {
    if (msg.accelerometers.size() == 0) {
      out << "accelerometers: []";
    } else {
      out << "accelerometers: [";
      size_t pending_items = msg.accelerometers.size();
      for (auto item : msg.accelerometers) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: vision
  {
    if (msg.vision.size() == 0) {
      out << "vision: []";
    } else {
      out << "vision: [";
      size_t pending_items = msg.vision.size();
      for (auto item : msg.vision) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: game_state
  {
    out << "game_state: ";
    to_flow_style_yaml(msg.game_state, out);
    out << ", ";
  }

  // member: agent_state
  {
    if (msg.agent_state.size() == 0) {
      out << "agent_state: []";
    } else {
      out << "agent_state: [";
      size_t pending_items = msg.agent_state.size();
      for (auto item : msg.agent_state) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: hears
  {
    if (msg.hears.size() == 0) {
      out << "hears: []";
    } else {
      out << "hears: [";
      size_t pending_items = msg.hears.size();
      for (auto item : msg.hears) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Percept & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: gyro_rates
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.gyro_rates.size() == 0) {
      out << "gyro_rates: []\n";
    } else {
      out << "gyro_rates:\n";
      for (auto item : msg.gyro_rates) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: hinge_joints
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.hinge_joints.size() == 0) {
      out << "hinge_joints: []\n";
    } else {
      out << "hinge_joints:\n";
      for (auto item : msg.hinge_joints) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: universal_joints
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.universal_joints.size() == 0) {
      out << "universal_joints: []\n";
    } else {
      out << "universal_joints:\n";
      for (auto item : msg.universal_joints) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: force_resistances
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.force_resistances.size() == 0) {
      out << "force_resistances: []\n";
    } else {
      out << "force_resistances:\n";
      for (auto item : msg.force_resistances) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: accelerometers
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.accelerometers.size() == 0) {
      out << "accelerometers: []\n";
    } else {
      out << "accelerometers:\n";
      for (auto item : msg.accelerometers) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: vision
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.vision.size() == 0) {
      out << "vision: []\n";
    } else {
      out << "vision:\n";
      for (auto item : msg.vision) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: game_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "game_state:\n";
    to_block_style_yaml(msg.game_state, out, indentation + 2);
  }

  // member: agent_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.agent_state.size() == 0) {
      out << "agent_state: []\n";
    } else {
      out << "agent_state:\n";
      for (auto item : msg.agent_state) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: hears
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.hears.size() == 0) {
      out << "hears: []\n";
    } else {
      out << "hears:\n";
      for (auto item : msg.hears) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Percept & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rcss3d_agent_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rcss3d_agent_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rcss3d_agent_msgs::msg::Percept & msg,
  std::ostream & out, size_t indentation = 0)
{
  rcss3d_agent_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rcss3d_agent_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const rcss3d_agent_msgs::msg::Percept & msg)
{
  return rcss3d_agent_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rcss3d_agent_msgs::msg::Percept>()
{
  return "rcss3d_agent_msgs::msg::Percept";
}

template<>
inline const char * name<rcss3d_agent_msgs::msg::Percept>()
{
  return "rcss3d_agent_msgs/msg/Percept";
}

template<>
struct has_fixed_size<rcss3d_agent_msgs::msg::Percept>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rcss3d_agent_msgs::msg::Percept>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rcss3d_agent_msgs::msg::Percept>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__PERCEPT__TRAITS_HPP_
